angular.module('bootcampApp')
  .service('Stupid', function($rootScope, $q){
    function randomIntFromInterval(min,max)
    {
      return Math.floor(Math.random()*(max-min+1)+min);
    }

    function startNumberGeneration(){
      var deferred = $q.defer();
      var p = deferred.promise;

      $rootScope.$evalAsync(function(){
        var min = 0,
            max = 50000;
        var magicNumber = randomIntFromInterval(min, max);
        var newNumber = null;
        var i = 0;

        do {
          newNumber = randomIntFromInterval(min, max);
          if(i % 50000 == 0){
            deferred.notify("Number " + newNumber + " being tried.");
          }
          i++;
        }while(magicNumber != newNumber);

        deferred.resolve("Number " + newNumber + " is the magic number.");
      });

      return p;
    }

    this.startNumberGeneration = startNumberGeneration;
  });
